﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Lab1
{
    /// <summary>
    /// Форма работы с объектом "Спортивный автомобиль"
    /// </summary>
    public partial class FormYborshik : Form
    {
        /// <summary>
        /// Поле-объект для прорисовки объекта
        /// </summary>
        private DrawningYborshik? _drawningYborshik;

        /// <summary>
        /// Конструктор формы
        /// </summary>
        public FormYborshik()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            if (_drawningYborshik == null)
            {
                return;
            }

            Bitmap bmp = new(pictureBoxYborshik.Width, pictureBoxYborshik.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawningYborshik.DrawTransport(gr);
            pictureBoxYborshik.Image = bmp;
        }

        /// <summary>
        /// Обработка нажатия кнопки "Создать"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawningYborshik = new DrawningYborshik();
            _drawningYborshik.Init(random.Next(100, 300), random.Next(1000, 3000),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
            _drawningYborshik.SetPictureSize(pictureBoxYborshik.Width, pictureBoxYborshik.Height);
            _drawningYborshik.SetPosition(random.Next(10, 100), random.Next(10, 100));
            Draw();
        }
        private void buttonMove_Click(object sender, EventArgs e)
        {
            if (_drawningYborshik == null)
            {
                return;
            }

            string name = ((Button)sender)?.Name ?? string.Empty;
            bool result = false;
            switch (name)
            {
                case "buttonUp":
                    result = _drawningYborshik.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    result = _drawningYborshik.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    result = _drawningYborshik.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    result = _drawningYborshik.MoveTransport(DirectionType.Right);
                    break;
            }

            if (result)
            {
                Draw();
            }
        }
    }
}
